! @(#)intell.prg	19.1 (ES0-DMD) 02/25/03 13:31:08
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.IDENTIFICATION: intell.prg
!.PURPOSE:	  Integrate pixel intensities within ellipse in 2-D image
!.USE:            INTEGR/ELLIPS P1 P2 P3
!		  P1 = inframe 
!		  P2 = ellipse parameters: center X, center Y, 
!		       semi-major diameter, semi-minor diameter, 
!		       position angle (degrees, 0 on X-axis, incr tow Y-axis)
!		  P3 = flag: 1 = ellipse parameters read from
!		       descriptor ELLPAR according to P2
!.NOTE:           Descriptor ELLPAR updated with flux in 6th element
!--------------------------------------------------------------------------
DEFINE/PARAM P1 ?  IMA               "Enter input image"
DEFINE/PARAM P2 'MORPH(1:50)'  N     "Ellipse center X,Y, semidiams, posangle:"
DEFINE/PARAM P3 0 N                  "Flag (1=ellipse params in descr ELLPAR):"
!
WRITE/KEYW IN_A  	'P1'       !write inframe into IN_A
!
WRITE/KEYW INPUTR/R/1/5  'P2'       !write ellipse parameters
WRITE/KEYW MORPH/C/1/50  'P2'
!
WRITE/KEYW INPUTI/I/1/1  'P3'       !write flag
!
DISPLAY/LONG
RUN CON_EXE:INTELL
