#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/* @(#)genftocb.fc	19.1 (ESO-DMD) 02/25/03 13:54:12 */
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++  GENFTOCB.FC  +++++++++++++++++++++++++++++++++++
.LANGUAGE C
.IDENTIFICATION Module genftocb.fc
.COMMENTS
Contains GENBLD, GENEQF, GENLEN, ISSUBF, DSCUPT
.AUTHOR         K. Banse  	ESO - Garching
.KEYWORDS       tools
.ENVIRONMENT    FORTRAN and C standards
.VERSION  
 [1.00] 920507: Created + extracted from genftoc.fc + utilz.fc

 021211		last modif

-----------------------------------------------------------------------------*/

#include <ftoc.h>
#include <midas_def.h>


#if 0     /* ==== Original Code ==== */
SUBROUTINE GENBLD(simno,name,datform,size,imno,cloned,status)
fint2c  *simno;		/* IN: = image id of source image */
CHARACTER   name;	/* IN: name of new image */
fint2c  *datform;	/* IN: = data format of new image */
fint2c  *size;		/* IN: = size of new image */
fint2c  *imno;		/* OUT: = image id of new image */
fint2c  *cloned;	/* OUT: =1 if descr's were cloned, else =0 */
fint2c *status;
#else     /* ==== Generated Code === */
#define GENBLD	genbld_
GENBLD(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

*PARAM(7,7,1,fint2c *) = CGN_IBUILD(*PARAM(1,7,0,fint2c *),STRIPPED_STRING(2,7,0),*PARAM(3,7,1,fint2c *),*PARAM(4,7,1,fint2c *),PARAM(5,7,1,fint2c *),PARAM(6,7,1,fint2c *));
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE GENEQF(afile,bfile,retval)
CHARACTER   afile;	/* IN: 1. file name */
CHARACTER   bfile;	/* IN: 2. file name */
fint2c	*retval;	/* OUT: =1 if Equal, =0 if Differ */
#else     /* ==== Generated Code === */
#define GENEQF	geneqf_
GENEQF(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

int retstat;  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */


retstat = CGN_EQUAL(STRIPPED_STRING(1,3,0),STRIPPED_STRING(2,3,1));
*PARAM(3,3,2,fint2c *) = 1 - retstat;		/* retstat = 0 if equal and 1 if not ...  */
  ftoc_free(FORmark);    /* <forif> */

}

#if 0     /* ==== Original Code ==== */
SUBROUTINE GENLEN(strung,retval)
CHARACTER   strung;	/* IN: 1. file name (terminated by \0) */
fint2c    *retval;
#else     /* ==== Generated Code === */
#define GENLEN	genlen_
GENLEN(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

*PARAM(2,2,1,fint2c *) = strlen(STRIPPED_STRING(1,2,0));
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE ISSUBF(infile,indx)
CHARACTER   infile;     /* IN: input file name                  */
fint2c *indx;		/* OUT: index of substring specs, else = 0 */
#else     /* ==== Generated Code === */
#define ISSUBF	issubf_
ISSUBF(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */


int nx;  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */


nx = issub(STRIPPED_STRING(1,2,0));
if (nx > 0)
   *PARAM(2,2,1,fint2c *) = nx + 1;		/* in C we start from 0 ...  */
else
   *PARAM(2,2,1,fint2c *) = 0;
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE DSCUPT(inno,outno,history,status)

fint2c    *inno;		/* IN: source file no. */
fint2c    *outno;		/* IN: dest. file no. */
CHARACTER   history;    /* IN: eventual history string */
fint2c *status;
#else     /* ==== Generated Code === */
#define DSCUPT	dscupt_
DSCUPT(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

*PARAM(4,4,1,fint2c *) = CGN_DSCUPD(*PARAM(1,4,0,fint2c *),*PARAM(2,4,0,fint2c *),C_STRING(3,4,0));
  ftoc_free(FORmark);    /* <forif> */
}

