#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/* @(#)stfc.fc	19.1 (ES0-DMD) 02/25/03 13:54:14 */
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
  MA 02139, USA.
 
  Corresponding concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++  STFC.FC +++++++++++++++++++++++++++++++++++++++
.LANGUAGE C
.IDENTIFICATION Module STFC.FC
.COMMENTS
Module contains layer between the frame related FORTRAN STxxxx interfaces
and the SC_interfaces written in (hopefully independent) C
.AUTHOR         K. Banse  	ESO - Garching
.KEYWORDS       standard interfaces.
.ENVIRONMENT    FORTRAN and C standards
.VERSION  [1.00] 871207:  created from SXFTOC.C
.VERSION  [2.60] 880415:  modified new version - the last one
.VERSION  [2.80] 900316:  fix problem with FNAME_LEN+2 ...
.VERSION  [3.00] 901213:  Master file. CG.

 020312		last modif

-----------------------------------------------------------------------------*/

#include <ftoc.h>
#include <ftoc_comm.h>
#include <midas_def.h>


#if 0     /* ==== Original Code ==== */
SUBROUTINE STFCRE(name,dattype,iomode,filtype,size,no,status)
CHARACTER   name;	/* IN: name of object */
fint2c *dattype;		/* IN: data types as defined in Module header  */
fint2c *iomode;		/* IN: opening mode, e.g. F_O_MODE, ...   */
fint2c *filtype;		/* IN: filetype no., e.g. F_TBL_TYPE, ... */
fint2c *size;		/* IN: size of object = no. of data values in file */
fint2c *no;		/* OUT: file no.  */
fint2c *status;
#else     /* ==== Generated Code === */
#define STFCRE	stfcre_
STFCRE(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

    *PARAM(7,7,1,fint2c *) = SCFCRE(STRIPPED_STRING(1,7,0),*PARAM(2,7,1,fint2c *),*PARAM(3,7,1,fint2c *),*PARAM(4,7,1,fint2c *),*PARAM(5,7,1,fint2c *),PARAM(6,7,1,fint2c *));
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE STFXCR(name,dattype,iomode,filtype,size,optflags,no,status)
CHARACTER   name;       /* IN: name of object */
fint2c *dattype;	/* IN: data types as defined in Module header */
fint2c *iomode;         /* IN: opening mode, e.g. F_O_MODE, ...   */
fint2c *filtype;                /* IN: filetype no., e.g. F_TBL_TYPE, ... */
fint2c *size;           /* IN: size of object = no. of data values in file */
fint2c *optflags;	/* IN: option for cloning descriptors;
			       = 0, NO (then same as SCFCRE)
			       = 1, Yes (optio(2) = imno of source frame) */
fint2c *no;             /* OUT: file no.  */
fint2c *status;
#else     /* ==== Generated Code === */
#define STFXCR	stfxcr_
STFXCR(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

*PARAM(8,8,1,fint2c *) = 
SCFXCR(STRIPPED_STRING(1,8,0),*PARAM(2,8,1,fint2c *),*PARAM(3,8,1,fint2c *),*PARAM(4,8,1,fint2c *),*PARAM(5,8,1,fint2c *),PARAM(6,8,1,fint2c *),PARAM(7,8,1,fint2c *));
  ftoc_free(FORmark);    /* <forif> */
}


