C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  TBC.FOR +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module TBC.FOR
C  AUTHOR         M. Peron (ESO-IPG))
C  Module contains layer between the table related FORTRAN TBxxxx interfaces
C  and the TC_interfaces written in (hopefully independent) C
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C -----------------------------------------------------------------------------
C

      SUBROUTINE TBCINI(TID,DTYPE,ALEN,FORM,TUNIT,LABEL,COL,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   FORM, TUNIT, LABEL
      INTEGER     TID, DTYPE, ALEN, COL
      INTEGER     STATUS
C 
      CALL TBC1(TID,FORM,DTYPE,ALEN)
      CALL TBC2(TUNIT,LABEL,COL,STATUS)
C
      RETURN
      END

      SUBROUTINE TBCPAM(TID,COL,START,ASKED,MAPPED,INDX,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     TID, COL, START, ASKED, MAPPED
      INTEGER*8   INDX
      INTEGER     STATUS
C
      CALL TBC1(TID,'dummy',COL,START)
      CALL TBC3(ASKED,MAPPED,INDX,STATUS)

C
      RETURN
      END

      SUBROUTINE TBCSEL(TID,TEXT,MAX_COLS,COLS,FLAGS,FOUND_COLS,STATUS)
C 
      IMPLICIT NONE
C
      CHARACTER*(*)   TEXT
      INTEGER     TID, MAX_COLS,COLS,FLAGS,FOUND_COLS
      INTEGER     STATUS
C
      CALL TBC1(TID,TEXT,MAX_COLS,0)
      CALL TBC4(COLS,FLAGS,FOUND_COLS,STATUS)

C
      RETURN
      END

