C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  TBE.FOR +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module TBE.FOR
C  AUTHOR         K. Banse
C  Module contains layer between the table related FORTRAN TBxxxx interfaces
C  and the TC_interfaces written in (hopefully independent) C
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C 
C 050728	last modif
C 
C -----------------------------------------------------------------------------
C
      SUBROUTINE TBERDC(TID, ROW, COL, VALUE, NULL, STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   VALUE
      INTEGER     TID, ROW, COL, NULL
      INTEGER     STATUS
C 
      CALL TBE1(TID,ROW,COL)
      CALL TBE2(VALUE, NULL, STATUS)

C
      RETURN
      END

      SUBROUTINE TBEGET(TID, TYPE, ROW, COL, VALUE, NULL, STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  TYPE
      INTEGER     TID, COL, ROW
      INTEGER     VALUE(*), NULL
      INTEGER     STATUS
C
      CALL TBE1(TID,ROW,COL)
      CALL TBE3(TYPE, VALUE, NULL, STATUS)

C
      RETURN
      END
C 
      SUBROUTINE TBETRC(TID, COL, TEXT, VALUE, STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  TEXT
      CHARACTER   VALUE(*)
      INTEGER     TID, COL
      INTEGER     STATUS
C
      CALL TBE1(TID,0,COL)
      CALL TBE4(TEXT, VALUE, STATUS)

C
      RETURN
      END
C 
      SUBROUTINE TBEPUT(TID, TYPE, ROW, COL, VALUE, STATUS)

C
      IMPLICIT NONE
C
      CHARACTER*(*)  TYPE
      INTEGER     TID, COL, ROW
      INTEGER     VALUE(*), NULL
      INTEGER     STATUS
C
      CALL TBE1(TID,ROW,COL)
      CALL TBE5(TYPE, VALUE, NULL, STATUS)

C
      RETURN
      END

      SUBROUTINE TBESRC(TID,COL,VALUE,START,LEN,FIRST,NEXT,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)  VALUE
      INTEGER     TID, COL, START, LEN, FIRST, NEXT
      INTEGER     STATUS
C
      CALL TBE1(TID,START,COL)
      CALL TBE6(VALUE,LEN, FIRST, NEXT, STATUS)
C
      RETURN
      END

      SUBROUTINE TBESRD(TID, COL, VALUE, TOLERANCE, FIRST, NEXT,STATUS)
C
      IMPLICIT NONE
C
      DOUBLE PRECISION  VALUE, TOLERANCE
      INTEGER     TID, COL, FIRST, NEXT
      INTEGER     STATUS
C
      CALL TBE1(TID,FIRST,COL)
      CALL TBE7(VALUE, TOLERANCE,NEXT, STATUS)
C
      RETURN
      END
      
      SUBROUTINE TBESRI(TID, COL, VALUE, TOLERANCE, FIRST, NEXT,STATUS)
C
      IMPLICIT NONE
C
      INTEGER     VALUE, TOLERANCE
      INTEGER     TID, COL, FIRST, NEXT
      INTEGER     STATUS
C
      CALL TBE1(TID,FIRST,COL)
      CALL TBE8(VALUE, TOLERANCE,NEXT, STATUS)
C
      RETURN
      END

      SUBROUTINE TBESRR(TID, COL, VALUE, TOLERANCE, FIRST, NEXT, STATUS)
C
      IMPLICIT NONE
C
      REAL     VALUE, TOLERANCE
      INTEGER     TID, COL, FIRST, NEXT
      INTEGER     STATUS
C
      CALL TBE1(TID,FIRST,COL)
      CALL TBE9(VALUE, TOLERANCE,NEXT, STATUS)
C
      RETURN
      END

