C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================

C ++++++++++++++++++++++++  TBR.FOR +++++++++++++++++++++++++++++++++++++++
C .LANGUAGE Fortran 77
C .IDENTIFICATION Module TBR.FOR
C  AUTHOR         K. Banse
C  Module contains layer between the table related FORTRAN TBxxxx interfaces
C  and the TC_interfaces written in (hopefully independent) C
C .KEYWORDS       standard interfaces.
C .ENVIRONMENT    FORTRAN and C standards
C .VERSION  [1.00] 871207:  created from SXFTOC.C
C 
C 050728	last modif
C 
C -----------------------------------------------------------------------------
C
      SUBROUTINE TBRRDC(TID, ROW, NC, COLS, VALUE, NULL, STATUS)

C
      IMPLICIT NONE
C
      CHARACTER   VALUE(*)
      INTEGER     TID, ROW, NC, COLS, NULL
      INTEGER     STATUS
C 
      CALL TBR1(TID,ROW,NC,COLS)
      CALL TBR2(VALUE, NULL, STATUS)

C
      RETURN
      END

      SUBROUTINE TBRRDD(TID, ROW, NC, COLS, VALUE, NULL, STATUS)
C
      IMPLICIT NONE
C
      INTEGER     TID, ROW, NC, COLS, NULL
      DOUBLE PRECISION     VALUE(*)
      INTEGER     STATUS
C
      CALL TBR1(TID,ROW,NC,COLS)
      CALL TBR3(VALUE, NULL, STATUS)
C
      RETURN
      END
C

      SUBROUTINE TBRRDI(TID, ROW, NC, COLS, VALUE, NULL, STATUS)
C
      IMPLICIT NONE
C
      INTEGER     TID, ROW, NC, COLS, NULL
      INTEGER     VALUE(*)
      INTEGER     STATUS
C
      CALL TBR1(TID,ROW,NC,COLS)
      CALL TBR4(VALUE, NULL, STATUS)
C
      RETURN
      END
C 

      SUBROUTINE TBRRDR(TID, ROW, NC, COLS, VALUE, NULL, STATUS)
C
      IMPLICIT NONE
C
      INTEGER     TID, ROW, NC, COLS, NULL
      REAL     VALUE(*)
      INTEGER     STATUS
C
      CALL TBR1(TID,ROW,NC,COLS)
      CALL TBR5(VALUE, NULL, STATUS)
C
      RETURN
      END
C

      SUBROUTINE TBRGET(TID, TYPE, ROW, NC, COLS, VALUE, NULL, STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   TYPE
      INTEGER     TID, ROW, NC, COLS, NULL
      INTEGER     VALUE(*)
      INTEGER     STATUS
C
      CALL TBR1(TID,ROW,NC,COLS)
      CALL TBR6(TYPE,VALUE, NULL, STATUS)
C
      RETURN
      END
C
      SUBROUTINE TBRSEL(TID,TEXT,NR,LBOUNDS,UBOUNDS,FOUND,STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   TEXT
      INTEGER     TID, NR,LBOUNDS,UBOUNDS,FOUND
      INTEGER     STATUS
C
      CALL TBR1(TID,NR,LBOUNDS,UBOUNDS)
      CALL TBR7(TEXT,FOUND,STATUS)
C
      RETURN
      END
C
      SUBROUTINE TBRWRC(TID, ROW, NC, COLS, VALUE, STATUS)
C
      IMPLICIT NONE
C
      CHARACTER*(*)   VALUE
      INTEGER     TID, ROW, NC, COLS
      INTEGER     STATUS
C
      CALL TBR1(TID,ROW, NC, COLS)
      CALL TBR8(VALUE, STATUS)
C
      RETURN
      END

