#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/* @(#)ptk.fc	19.1 (ES0-DMD) 02/25/03 13:56:36 */
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
  MA 02139, USA.
 
  Corresponding concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
.COPYRIGHT      (c) 1993 European Southern Observatory
.IDENTifier     PTK.FC
.AUTHOR         Rein H. Warmels, ESO-IPG
.KEYWORDS       High level graphics interface, Graphics keywords
.LANGUAGE       C
.PURPOSE        Fortran to C interface for PCK
.COMMENTS       Module contains interfaces for the keyword routines
.ENVIRONMENT    MIDAS FORTRAN and C standards
.VERSION        1.0 13-Oct-1993 RHW
-----------------------------------------------------------------------------*/
#include <proto_plt.h>
#include <ftoc.h>
#include <midas_def.h>


#if 0     /* ==== Original Code ==== */
SUBROUTINE PTKRDC(cpar,maxvals,actvals,cval)
CHARACTER   cpar;	/* IN : name of variable in PLCSTAT */
fint2c	*maxvals;	/* IN : no. of elements to get */
fint2c	*actvals;	/* OUT: actual no. of elements returned */
CHARACTER   cval;	/* OUT: values for the parameters */
#else     /* ==== Generated Code === */
#define PTKRDC	ptkrdc_
PTKRDC(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

     char mycval[80] ;  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

     PCKRDC(STRIPPED_STRING(1,4,0),*PARAM(2,4,1,fint2c *),PARAM(3,4,1,fint2c *),mycval);
     STRFCOPY(4,4,1,mycval);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE PTKRDI(ipar,maxvals,actvals,ival)
CHARACTER   ipar;	/* IN : name of variable in PLISTAT */
fint2c	*maxvals;	/* IN : no. of elements to get  */
fint2c	*actvals;	/* OUT: actual no. of elements returned */
fint2c	   *ival;	/* OUT: values for the parameters */
#else     /* ==== Generated Code === */
#define PTKRDI	ptkrdi_
PTKRDI(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */
	
     PCKRDI(STRIPPED_STRING(1,4,0),*PARAM(2,4,1,fint2c *),PARAM(3,4,1,fint2c *),PARAM(4,4,1,fint2c *));
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE PTKRDR(rpar,maxvals,actvals,rval)
CHARACTER   rpar;	/* IN : name of variable in PLRSTAT */
fint2c	*maxvals;	/* IN : no. of elements to get */
fint2c	*actvals;	/* OUT: actual no. of elements returned */
float	   *rval;	/* OUT: values for the parameters */
#else     /* ==== Generated Code === */
#define PTKRDR	ptkrdr_
PTKRDR(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */
	
     PCKRDR(STRIPPED_STRING(1,4,0),*PARAM(2,4,1,fint2c *),PARAM(3,4,1,fint2c *),PARAM(4,4,1,float *));
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE PTKWRC(cpar,value)
CHARACTER   cpar;	/* IN : name of variable in PLCSTAT */
CHARACTER  value;	/* IN : values for the parameters */
#else     /* ==== Generated Code === */
#define PTKWRC	ptkwrc_
PTKWRC(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */
	
     PCKWRC(STRIPPED_STRING(1,2,0),STRIPPED_STRING(2,2,1));
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE PTKWRI(ipar,nrval,ival)
CHARACTER   ipar;	/* IN : name of variable in PLISTAT */
fint2c    *nrval;	/* IN : no. of elements to write  */
fint2c	   *ival;	/* IN : values for the parameters */
#else     /* ==== Generated Code === */
#define PTKWRI	ptkwri_
PTKWRI(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */
	
     PCKWRI(STRIPPED_STRING(1,3,0),*PARAM(2,3,1,fint2c *),PARAM(3,3,1,fint2c *));
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE PTKWRR(rpar,nrval,rval)
CHARACTER   rpar;	/* IN : name of variable in PLRSTAT */
fint2c	  *nrval;	/* IN : no. of elements to write  */
float	   *rval;	/* IN : values for the parameters */
#else     /* ==== Generated Code === */
#define PTKWRR	ptkwrr_
PTKWRR(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */
	
     PCKWRR(STRIPPED_STRING(1,3,0),*PARAM(2,3,1,fint2c *),PARAM(3,3,1,float *));
  ftoc_free(FORmark);    /* <forif> */
}

#define PTKDEF	ptkdef_
ROUTINE PTKDEF()
{ 
     PCKDEF();
}





