#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/
 
#include <ftoc.h>
#include <midas_def.h>

#define MAXDIM  3


static char savstring[96];
static int  savimno;

/*
^L
*/

/*
OJO: do not pass single float values, they get passed as double,
     always use pointers
*/

#if 0     /* ==== Original Code ==== */
SUBROUTINE YEXT1(imno,string)
fint2c  *imno;        /* IN : image id */
CHARACTER  string;    /* IN : OPCODE or CFUNC */
#else     /* ==== Generated Code === */
#define YEXT1	yext1_
YEXT1(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

strncpy(savstring,STRIPPED_STRING(2,2,0),90);
savstring[90] = '\0';

savimno = *PARAM(1,2,0,fint2c *);
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE YART2(flag,npix,size,retimno,stat)
fint2c   *flag;	
fint2c   *npix;	
fint2c   *size;
fint2c   *retimno;
fint2c   *stat;
#else     /* ==== Generated Code === */
#define YART2	yart2_
YART2(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs,noargs);       /* <forif> */

*PARAM(5,5,0,fint2c *) = Fillima(*PARAM(1,5,0,fint2c *),savimno,PARAM(2,5,0,fint2c *),savstring,PARAM(3,5,0,fint2c *),PARAM(4,5,0,fint2c *));
}

/*

*/

#if 0     /* ==== Original Code ==== */
SUBROUTINE YEXTC1(pixdim,subdim,sublo,subhi,stat)
fint2c   *pixdim;	
fint2c   *subdim;
fint2c   *sublo;
fint2c   *subhi;
fint2c   *stat;
#else     /* ==== Generated Code === */
#define YEXTC1	yextc1_
YEXTC1(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */

int   n, mydim, mysubdim, mylo[MAXDIM], myhi[MAXDIM];  va_start(Cargs,noargs);       /* <forif> */



mydim = *PARAM(1,5,0,fint2c *);
*PARAM(5,5,0,fint2c *) = Convcoo(1,savimno,savstring,mydim,&mysubdim,mylo,myhi);

*PARAM(2,5,0,fint2c *) = mysubdim;
for (n=0; n<mydim; n++)			/* move to Fortran counting */
   {PARAM(3,5,0,fint2c *)[n] = mylo[n] + 1;PARAM(4,5,0,fint2c *)[n] = myhi[n] + 1;
   }

}

/*

*/

#if 0     /* ==== Original Code ==== */
SUBROUTINE YEXTC2(pixdim,subdim,sublo,subhi,stat)
fint2c   *pixdim;
fint2c   *subdim;
fint2c   *sublo;
float   *subhi;
float   *stat;
#else     /* ==== Generated Code === */
#define YEXTC2	yextc2_
YEXTC2(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */

int   n, mydim, mysubdim;
float  mylo[MAXDIM], myhi[MAXDIM];  va_start(Cargs,noargs);       /* <forif> */



mydim = *PARAM(1,5,0,fint2c *);
*PARAM(5,5,0,float *) = XConvcoo(1,savimno,savstring,mydim,&mysubdim,mylo,myhi);

*PARAM(2,5,0,fint2c *) = mysubdim;
for (n=0; n<mydim; n++)                 /* move to Fortran counting */
   {PARAM(3,5,0,fint2c *)[n] = mylo[n] + 1;PARAM(4,5,0,float *)[n] = myhi[n] + 1;
   }

}

/*

*/

#if 0     /* ==== Original Code ==== */
SUBROUTINE YEXC1(pixdim,subdim,sublo,stat)
fint2c   *pixdim;
fint2c   *subdim;
fint2c   *sublo;
fint2c   *stat;
#else     /* ==== Generated Code === */
#define YEXC1	yexc1_
YEXC1(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */

int   n, mydim, mysubdim, mylo[MAXDIM], myhi[MAXDIM];  va_start(Cargs,noargs);       /* <forif> */



mydim = *PARAM(1,4,0,fint2c *);
*PARAM(4,4,0,fint2c *) = Convcoo(0,savimno,savstring,mydim,&mysubdim,mylo,myhi);

*PARAM(2,4,0,fint2c *) = mysubdim;
for (n=0; n<mydim; n++)                 /* move to Fortran counting */PARAM(3,4,0,fint2c *)[n] = mylo[n] + 1;

}

/*

*/

#if 0     /* ==== Original Code ==== */
SUBROUTINE YEXC2(pixdim,subdim,sublo,stat)
fint2c   *pixdim;
fint2c   *subdim;
float   *sublo;
float   *stat;
#else     /* ==== Generated Code === */
#define YEXC2	yexc2_
YEXC2(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */

int   n, mydim, mysubdim;
float  mylo[MAXDIM], myhi[MAXDIM];  va_start(Cargs,noargs);       /* <forif> */



mydim = *PARAM(1,4,0,fint2c *);
*PARAM(4,4,0,float *) = XConvcoo(0,savimno,savstring,mydim,&mysubdim,mylo,myhi);

*PARAM(2,4,0,fint2c *) = mysubdim;
for (n=0; n<mydim; n++)                 /* move to Fortran counting */PARAM(3,4,0,float *)[n] = mylo[n] + 1;

}





