#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/* +++++++++++++++++++++++++  f2cgen.fc  +++++++++++++++++++++++++++++
.LANGUAGE  C
.AUTHOR    K. Banse		ESO - IPG, Garching
.IDENT     Module F2CGEN.FC
.PURPUSE   fortran to C interfaces for general routines
.VERSION   [1.00]  940327
 030519		last modif

------------------------------------------------------------------------*/

#include <midas_def.h>
#include <proto_gen.h> 
#include <ftoc.h>


static int  *pnpixA, *pnpixB, *pbgnA, *pbgnB;
static int   npix[2];
static float xycen[2];
static float *pmag, *pdmag, *psky, *pdsky;
static float *pxsig, *pysig, *pxyval;

/*

*/

#define YY1	yy1_
ROUTINE YY1(npixA,npixB,bgnA,bgnB)
fint2c  *npixA;
fint2c  *npixB;
fint2c  *bgnA;
fint2c  *bgnB;

{
pnpixA = npixA;
pnpixB = npixB;

pbgnA = bgnA;
pbgnB = bgnB;
}

#define YY1a	yy1a_
ROUTINE YY1a(nx,ny,xc,yc)
fint2c *nx;
fint2c *ny;
float  *xc;
float  *yc; 

{
npix[0]  = *nx;
npix[1]  = *ny;
xycen[0] = *xc - 1.0;           /* use C indexing for Cjmagn */
xycen[1] = *yc - 1.0;
}

#define YY1b	yy1b_
ROUTINE  YY1b(mag,dmag,sky,dsky)
float  *mag;
float  *dmag;
float  *sky;
float  *dsky;

{
pmag = mag;
pdmag = dmag;
psky = sky;
pdsky = dsky;
}

#define YY1c	yy1c_
ROUTINE YY1c(xsig,ysig,xyval)
float  *xsig;
float  *ysig;
float  *xyval;

{
pxsig = xsig;
pysig = ysig;
pxyval = xyval;
}

#define YY2	yy2_
ROUTINE YY2(pntrA,pntrB,endA)
float   *pntrA;
float   *pntrB;
fint2c  *endA;
{
Ccopwnd(pntrA,pnpixA,pntrB,pnpixB,pbgnA,pbgnB,endA );
}

#define YY3	yy3_
ROUTINE YY3(pntrA,dimwA,pntrB)
float   *pntrA;
fint2c  *dimwA;
float   *pntrB;
{
Ccopyf1(pntrA,pnpixA,pbgnA,dimwA,pntrB,pnpixB,pbgnB);
}

#define YY4	yy4_
ROUTINE YY4(arr,fac,nrpix,flux,stat)
float  *arr; 
float  *fac;
float  *nrpix;
float  *flux;
fint2c *stat;

/*	jmeth -> pnpixA, ni -> pnpixB, nb -> pbgnA  */

{
*stat = Cjmagn(*pnpixA,arr,npix,*pnpixB,*pbgnA,fac,xycen,
               pmag,pdmag,psky,pdsky,nrpix,flux);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE YY5(p_img,meth,image,stat)
float  *p_img;
CHARACTER meth;
fint2c *image;
fint2c *stat;
#else     /* ==== Generated Code === */
#define YY5	yy5_
YY5(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

int   imap[4];
float xypos[2], xyerr[2], xysig[2];  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */


imap[0] =PARAM(3,4,1,fint2c *)[0] - 1;
imap[1] =PARAM(3,4,1,fint2c *)[1] - 1;
imap[2] =PARAM(3,4,1,fint2c *)[2] - 1;
imap[3] =PARAM(3,4,1,fint2c *)[3] - 1;

/*    CALL YY1a(DIMX,DIMY,0.,0.)
      CALL YY1b(XOUT,YOUT,XERR,YERR)
      CALL YY1c(XSIG,YSIG,XYVAL)      */

*PARAM(4,4,1,fint2c *) = Cstacen(STRIPPED_STRING(2,4,0),PARAM(1,4,0,float *),npix,imap,xypos,xyerr,xysig,pxyval);

*pmag = xypos[0] + 1;
*pdmag = xypos[1] + 1;
*psky = xyerr[0];
*pdsky = xyerr[1];
*pxsig = xysig[0];
*pysig = xysig[1];
  ftoc_free(FORmark);    /* <forif> */
}

#define YY6	yy6_
ROUTINE YY6(step,xindx,yindx,limit,nindx)
float  *step;
fint2c *limit;
float  *xindx;
float  *yindx;
fint2c *nindx;
{
double dstep = *step;
*nindx = Cpixlin(*pmag,*pdmag,*psky,*pdsky,dstep,*limit,xindx,yindx);
}

#define YY7	yy7_
ROUTINE YY7(p_in,npix,ndim,p_out)
float  *p_in;
fint2c *npix;
fint2c *ndim;
float  *p_out;
{
Czima(p_in,npix,pmag,pdmag,*ndim,p_out,psky,pdsky);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE YY8(infile,a,b,fmin,fmax)
CHARACTER infile;
float     *a;
fint2c    *b;
float     *fmin;
float     *fmax;
#else     /* ==== Generated Code === */
#define YY8	yy8_
YY8(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

/* YY1(DATTYP,TOTAL,MINFLG,0) */  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */


ReadASCI(STRIPPED_STRING(1,5,0),*pnpixA,*pnpixB,PARAM(2,5,1,float *),PARAM(3,5,1,fint2c *),*pbgnA,PARAM(4,5,1,float *),PARAM(5,5,1,float *));
  ftoc_free(FORmark);    /* <forif> */
}

