#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/* +++++++++++++++++++++++++  f2cgena.fc  +++++++++++++++++++++++++++++
.LANGUAGE  C
.AUTHOR    K. Banse		ESO - IPG, Garching
.IDENT     Module f2cgena.fc
.PURPUSE   Fortran to C interfaces for general routines
.VERSION   [1.00]  940327

 050727		last modif

------------------------------------------------------------------------*/

#include <midas_def.h>
#include <proto_gen.h> 
#include <ftoc.h>

#define LUTSIZE 256

/*

*/

#define COPYF2	copyf2_
ROUTINE COPYF2( value, pntrB, npixB, bgnB, dimwB )
float   *value;
float   *pntrB;
fint2c  *npixB;
fint2c  *bgnB;
fint2c  *dimwB;
{
Ccopyf2( *value, pntrB, npixB, bgnB, dimwB );
}

#define COPYF	copyf_
ROUTINE COPYF( pntrA, pntrB, dim )
float  *pntrA;
float  *pntrB;
fint2c *dim;
{
Ccopyf( pntrA, pntrB, *dim );
}

#define COPYI	copyi_
ROUTINE COPYI( pntrA, pntrB, dim )
fint2c *pntrA;
fint2c *pntrB;
fint2c *dim;
{
Ccopyi( pntrA, pntrB, *dim );
}

/*
ROUTINE CONFIL( value, pntrB, dim )
float  *value;
float  *pntrB;
fint2c *dim;
{
Cconfil( *value, pntrB, *dim );
}
*/

#define COPYFX	copyfx_
ROUTINE COPYFX( pntrA, imni, imno, npix, istrip )
float   *pntrA;
fint2c  *imni;
fint2c  *imno;
fint2c  *npix;
fint2c  *istrip;
{
Ccopyfx( pntrA, *imni, *imno, npix, *istrip );
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE FRAMOU( frame )
CHARACTER frame;
#else     /* ==== Generated Code === */
#define FRAMOU	framou_
FRAMOU(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

FRAMOU_C(STRIPPED_STRING(1,1,0));
  ftoc_free(FORmark);    /* <forif> */
}

#define FPXWCO	fpxwco_
ROUTINE FPXWCO(flag,imno,ccin,ccout,stat)
fint2c  *flag;		/* 0: init, 1: fp -> wc, -1: wc -> fp */
fint2c  *imno;		/* only used for flag = 0 */
double  *ccin;		/* fp's (1) or wc's (-1) */
double  *ccout;		/* wc's (-1) or fp's (1) */
fint2c *stat;		/* 0 = o.k. for flag != 0
                           0 or -1 for flag=0 to tell, 
                                   if non- or linear coord system
                           > 0 if error for all flags  */
{
*stat = fp2wc(*flag,*imno,ccin,ccout);		/* in file wrldco.c */
}

#define CPOWER	cpower_
ROUTINE CPOWER(xa, xb, xc)
float  *xa;
float  *xb;
float  *xc;
{
MyPower(xa,xb,xc);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE OPNTAB( table, tid, ncols, nrows, stat )
CHARACTER table;
fint2c    *tid;
fint2c    *ncols;
fint2c    *nrows;
fint2c    *stat;
#else     /* ==== Generated Code === */
#define OPNTAB	opntab_
OPNTAB(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

*PARAM(5,5,1,fint2c *) = 0;
OPNTBL(CHAR_LOC(1,5,0),PARAM(2,5,1,fint2c *),PARAM(3,5,1,fint2c *),PARAM(4,5,1,fint2c *));
  ftoc_free(FORmark);    /* <forif> */
}

static void worky(mlut,qlut)
float *mlut, *qlut;
{
register int jin, jout, jouta, joutb;

jout = 0;
jouta = LUTSIZE;
joutb = LUTSIZE + LUTSIZE;

for (jin=0; jin<3*LUTSIZE; jin+=3)
   {
   mlut[jout++] = qlut[jin];
   mlut[jouta++] = qlut[jin+1];
   mlut[joutb++] = qlut[jin+2];
   }
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE BLDLUT(table,rlut,stat)
CHARACTER table;
float     *rlut;
fint2c    *stat;
#else     /* ==== Generated Code === */
#define BLDLUT	bldlut_
BLDLUT(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

float mylut[3*LUTSIZE];

int range[2];  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */


*PARAM(3,3,1,fint2c *) = 0;
worky(mylut,PARAM(2,3,1,float *));		/* no index massaging of MACRO stuff...!  */

range[0] = 0;
range[1] = 1;
CRELUT(CHAR_LOC(1,3,0),mylut,LUTSIZE,0,range);
  ftoc_free(FORmark);    /* <forif> */

}

#if 0     /* ==== Original Code ==== */
SUBROUTINE BLDITT( table, ritt, stat )
CHARACTER table;
float     *ritt;
fint2c    *stat;
#else     /* ==== Generated Code === */
#define BLDITT	blditt_
BLDITT(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

*PARAM(3,3,1,fint2c *) = 0;
CREITT( CHAR_LOC(1,3,0 ),PARAM(2,3,1,float *) );
  ftoc_free(FORmark);    /* <forif> */
}

#define HACKUP	hackup_
ROUTINE HACKUP(npix, pix_form, retbuf)
fint2c *npix;
fint2c *pix_form;
fint2c *retbuf;

{
void hack_up();


hack_up(npix,*pix_form,retbuf);
}
