#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/* =======================================================================
  Copyright (C) 1995-2005 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
 	Internet e-mail: midas@eso.org
 	Postal address: European Southern Observatory
 			Data Management Division 
 			Karl-Schwarzschild-Strasse 2
 			D 85748 Garching bei Muenchen 
 			GERMANY
 ======================================================================== */
 
 
#include <ftoc.h>
#include <midas_def.h>
#include <proto_gen.h>

static char savbuf[8];
static int  savndim;
static float *pusrnul;

/*

*/

/*
OJO: do not pass single float values, they get passed as double,
     always use pointers 
*/

#if 0     /* ==== Original Code ==== */
SUBROUTINE YOP1(cbuf,ndim,usrnul)
CHARACTER  cbuf;      /* IN : OPCODE or CFUNC */
fint2c  *ndim;        /* IN : dimension */
float  *usrnul;       /* IN : user defined null value */
#else     /* ==== Generated Code === */
#define YOP1	yop1_
YOP1(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */
  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */

strncpy(savbuf,STRIPPED_STRING(1,3,0),6);
savbuf[6] = '\0';

savndim = *PARAM(2,3,1,fint2c *);
pusrnul =PARAM(3,3,1,float *);			/* pointer */
  ftoc_free(FORmark);    /* <forif> */
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE YOPFC(a,rconst,c,ncount)
float     *a;
float     *rconst;
float     *c;
fint2c    *ncount;
#else     /* ==== Generated Code === */
#define YOPFC	yopfc_
YOPFC(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs,noargs);       /* <forif> */

*PARAM(4,4,0,fint2c *) = OpFrameCons(savbuf,PARAM(1,4,0,float *),PARAM(2,4,0,float *),PARAM(3,4,0,float *),savndim,pusrnul);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE YOPFF(a,b,c,ncount)
float     *a;
float     *b;
float     *c;
fint2c    *ncount;
#else     /* ==== Generated Code === */
#define YOPFF	yopff_
YOPFF(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs,noargs);       /* <forif> */

*PARAM(4,4,0,fint2c *) = OpFrameFrame(savbuf,PARAM(1,4,0,float *),PARAM(2,4,0,float *),PARAM(3,4,0,float *),savndim,pusrnul);
}
/*

*/

#if 0     /* ==== Original Code ==== */
SUBROUTINE YFUN1F(a,c,ncount)
float     *a;
float     *c;
fint2c    *ncount;
#else     /* ==== Generated Code === */
#define YFUN1F	yfun1f_
YFUN1F(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs,noargs);       /* <forif> */

*PARAM(3,3,0,fint2c *) = Func1Frame(savbuf,PARAM(1,3,0,float *),PARAM(2,3,0,float *),savndim,pusrnul);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE YF2FF(a,b,c,ncount)
float     *a;
float     *b;
float     *c;
fint2c    *ncount;
#else     /* ==== Generated Code === */
#define YF2FF	yf2ff_
YF2FF(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs,noargs);       /* <forif> */

*PARAM(4,4,0,fint2c *) = Func2Frame(savbuf,PARAM(1,4,0,float *),PARAM(2,4,0,float *),PARAM(3,4,0,float *),savndim,pusrnul);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE YF2FC(a,scalr,c,ncount)

float     *a;
float     *scalr;
float     *c;
fint2c    *ncount;
#else     /* ==== Generated Code === */
#define YF2FC	yf2fc_
YF2FC(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs,noargs);       /* <forif> */

*PARAM(4,4,0,fint2c *) = Func2FrameCon(savbuf,PARAM(1,4,0,float *),PARAM(2,4,0,float *),PARAM(3,4,0,float *),savndim,pusrnul);
}
/*

*/

#if 0     /* ==== Original Code ==== */
SUBROUTINE YDOPFC(a,scalr,c,ncount)

double     *a;
double     *scalr;
double     *c;
fint2c    *ncount;
#else     /* ==== Generated Code === */
#define YDOPFC	ydopfc_
YDOPFC(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs,noargs);       /* <forif> */

*PARAM(4,4,0,fint2c *) = DOpFrameCons(savbuf,PARAM(1,4,0,double *),PARAM(2,4,0,double *),PARAM(3,4,0,double *),savndim,pusrnul);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE YDOPFF(a,b,c,ncount)
double     *a;
double     *b;
double     *c;
fint2c    *ncount;
#else     /* ==== Generated Code === */
#define YDOPFF	ydopff_
YDOPFF(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs,noargs);       /* <forif> */

*PARAM(4,4,0,fint2c *) = DOpFrameFrame(savbuf,PARAM(1,4,0,double *),PARAM(2,4,0,double *),PARAM(3,4,0,double *),savndim,pusrnul);
}
/*

*/

#if 0     /* ==== Original Code ==== */
SUBROUTINE YDF1F(a,c,ncount)
double     *a;
double     *c;
fint2c    *ncount;
#else     /* ==== Generated Code === */
#define YDF1F	ydf1f_
YDF1F(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs,noargs);       /* <forif> */

*PARAM(3,3,0,fint2c *) = DFunc1Frame(savbuf,PARAM(1,3,0,double *),PARAM(2,3,0,double *),savndim,pusrnul);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE YDF2FF(a,b,c,ncount)

double     *a;
double     *b;
double     *c;
fint2c    *ncount;
#else     /* ==== Generated Code === */
#define YDF2FF	ydf2ff_
YDF2FF(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs,noargs);       /* <forif> */

*PARAM(4,4,0,fint2c *) = DFunc2Frame(savbuf,PARAM(1,4,0,double *),PARAM(2,4,0,double *),PARAM(3,4,0,double *),savndim,pusrnul);
}

#if 0     /* ==== Original Code ==== */
SUBROUTINE YDF2FC(a,scalr,c,ncount)
double     *a;
double     *scalr;
double     *c;
fint2c    *ncount;
#else     /* ==== Generated Code === */
#define YDF2FC	ydf2fc_
YDF2FC(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  va_start(Cargs,noargs);       /* <forif> */

*PARAM(4,4,0,fint2c *) = DFunc2FrameCon(savbuf,PARAM(1,4,0,double *),PARAM(2,4,0,double *),PARAM(3,4,0,double *),savndim,pusrnul);
}

