! @(#)center.prg	19.1 (ESO-DMD) 02/25/03 14:08:45
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure center.prg for CENTER/GAUSS, /MOMENT
! P. Ballester  910315
! K. Banse	890509, 900220, 900727, 920228, 920721, 940321
! J.D.Ponz	861128
!
! use via CENTER/method in_specs out_specs out_option
!                       curs_option xsize,ysize zw_option invert_flag
!
!  in_specs = CURSOR  or  inframe,fxpix,fypix  or  inframe,intable  or  inframe
!             or 
!             GCURSOR for one-dimensional centering via graphics cursor
! 
!  out_specs = ?      just display data
!	     = table  if output to table (may be same as intable or new one)
!	     = descr/D   descriptor name (of inframe)
! 
!  out_option = ID, for table
!		A, append flag for descriptor
!               or
!               EMISSION ABSORBTION
! 
!  curs_option = no_of_cursors,draw_flag,maxno_curs
!  xsize,ysize = size of window in frame pixels  (used where applicable)
!  zw_option = zoom_window_flag,zoom;
!                zoom_window_flag = W for zoom_window, N for none,
!                zoom = initial zoom factor;
!  invert_flag = YES or NO, if the center is not at a Gaussian peak but a 
!                Gaussian valley, defaulted to NO
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!  
if p1(1:5) .eq. "GCURS" then			!1D frame
   if mid$cmnd(11:11) .ne. "G" .and. mid$cmnd(11:11) .ne. "M" then
      write/out "Unknown option for GCURSOR (gravity, gauss and minmax only)"
      return/exit
   endif
   define/param p2 GCURSOR  TAB "Enter Table: "
   define/param p3 EMISSION C   "Enter type of lines: "
   run MID_EXE:centerrow
   return
endif
! 
!
! here for the 2-d stuff
!
!
action(1:1) = mid$cmnd(11:11)
! 
define/param p1 CURSOR C "Enter input_specs: "
define/param p2 + C "Enter output_specs: "
define/param p3 + C "Enter out_options: "
define/param p5 50,50 N "Enter size of window in frame pixels:"
write/keyw inputi {p5},{p5}
define/param p7 NO C "Enter invert_flag, YES/NO: "
action(2:2) = p7(1:1)
! 
if p1(1:6) .eq. "CURSOR" then		!interactive input via cursor
   define/param p4 2,1,9999 C  "Enter no_of_cursors,draw_flag,maxno_curs: "
   define/param p6 + ? "Enter zoom_window_flag,zoom: "
   write/keyw cursor 2,1,9999
   write/keyw cursor {p4}
   write/keyw in_a *			!filename here
   !
   dazin(1) = -1
   if p6(1:1) .eq. "W" then
      if p6(2:2) .eq. "," then
         dazin(1) = {p6(3:)}
      else
         dazin(1) = 4                          !default to 4*zoom
      endif
      in_b(1:1) = "?"                          !force to default Xstation
   endif
endif
! 
write/keyw inputc {p2}				!fill output_specs
write/keyw inputc/c/31/2 {p3}
! 
run MID_EXE:center
 
