! @(#)plottbl.prg	19.2 (ESO-DMD) 06/05/03 11:36:06
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.IDENTIFICATION: PLOTTBL.PRG
!.PURPOSE: MIDAS procedute to plot one or two planes of a 3D table
!.USE:     execute as @@ PLOTTBL par1 [par2] [par3] [par4] [par5] [par6] 
!          where:
!          par1 = input table
!          par2 = plane 1
!          par3 = plane 2
!          par4 = sc_x,sc_y,off_x,off_y (defaults device filling)
!          par5 = symbol types
!          par6 = line types
!          par7 = direction in which way the plane is read
!.AUTHOR:  R.M. van Hees
!.VERSION: 931001 - RvH creation
!.VERSION: 941025 - fix procedure + add automatic graph-window creation, KB
! ----------------------------------------------------------------------
! 
DEFINE/PARAM P1 ?  TABLE "Enter table:"
! define/local cmnd/c/1/20 "{mid$cmnd(1:20)}"		!save MID$CMND
!
IF P2(1:1) .EQ. "?" THEN
   DEFINE/PARAM P3 ? C "Enter input for the ordinate column:"
   IF P3(1:3) .EQ. "SEQ" THEN
      WRITE/OUT "*** FATAL: Illegal combination of column parameters"
      RETURN
   ENDIF
ENDIF
!
IF P2(1:3) .EQ. "SEQ" THEN
   DEFINE/PARAM P3 ? C "Enter input for the ordinate column:"
   IF P3(1:3) .EQ. "SEQ" THEN
      WRITE/OUT "*** FATAL: Illegal combination of column parameters"
      RETURN
   ENDIF
ENDIF
!
DEFINE/PARAM P7 DEFAULT,DEFAULT  C
! 
WRITE/KEYW IN_A 		{P1}
WRITE/KEYW INPUTC/C/1/20	{P7}
! 
IF MID$CMND(1:1) .EQ. "P" THEN
   DEFINE/PARAM P4 0.0,0.0,-999,-999 NUM
   @ plscoff.prg_o {P4}
   DATTIM = M$TIME()
   RUN MID_EXE:PLOTTBL
ELSE
   DEFINE/PARAM P4 {PLISTAT(6)} NUM
   DEFINE/LOCAL ITYPE/I/1/1 {PLISTAT(6)}
   WRITE/KEYW PLISTAT/I/6/1 {P4}
   RUN MID_EXE:PLOTTBL
   WRITE/KEYW PLISTAT/I/6/1 {ITYPE} 
ENDIF
!
WRITE/KEYW PLCDATA/C/1/60  {P1}
WRITE/KEYW PLCDATA/C/61/20 "TABLE       " 
copy/graph

