#define vmr	vmr_		/* parameter for Name Translation is l_ */
#define ROUTINE int
/*===========================================================================
  Copyright (C) 1995-2005 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
  MA 02139, USA.
 
  Correspondence concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/*++++++++++++++
.IDENTIFICATION ftoc_test.fc
.LANGUAGE       C
.AUTHOR         Francois Ochsenbein
.ENVIRONMENT    Any
.KEYWORDS       Fortran to C interface
.COMMENTS       This subroutine is called from fortest.f
.VERSION  1.0   16-Oct-1990

 050803		last modif
---------------*/

#include <ftoc_test.h>

#ifndef VOIDSIG
#define VOIDSIG   void
#endif

/*==========================================================================
 *	We just define here exception routines, in case this fails...
 *==========================================================================*/
#include <signal.h>
#ifndef NSIG
#define NSIG 32
#endif

static VOIDSIG exception(s) int s;
{
	char msg[80];

   (void) sprintf(msg, "**** Error (%d)\n", s);
   osdwrite (2, msg, strlen(msg));
   ospexit(1);
}

/*==========================================================================*/

#if 0     /* ==== Original Code ==== */
SUBROUTINE SSP1(s1, n1, s2, n2)
/*++++++++++++++++
.PURPOSE  Check Fortran to C Interface (FORTRAN SSP1 in for_test.for)
.RETURNS  0 (All OK) / -1 (Error)
-----------------*/
CHARACTER s1;	/* Fortran String*79 */
CHARACTER s2;	/* Fortran String*161*/
INT n1;		/* -71 */
INT n2;         /* -2  */
#else     /* ==== Generated Code === */
#define SSP1	ssp1_
SSP1(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

static char Cs1[] = "sY<01234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ>";
static char Cs2[] = "s2<abcdefghijklmnopqrstuvwxyz01234567890>XYZ";
 
int  k, j1, j2, stat;  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */



for (k = 1; k <= NSIG; k++)	signal (k,  exception);
stat = 0;

/*
printf("here in SSP1 ...\n");
printf("n1 = %d, n2 = %d\n",*n1,*n2);
printf("length of s1 = %d, s2 = %d\n",j1,j2);
*/	


			/* Check the Length */

j1 = CHAR_LEN(1,4,0);
j2 = CHAR_LEN(3,4,1);


if (CHAR_LEN(1,4,0) != 79)	stat += 1;
if (CHAR_LEN(3,4,1) != 161) stat += 2;

if (stat) 
   {
   (void) printf("**** String length not recognized ****, status = %x (as %%x)\n",stat);
   ospexit(1);
   }

			/* Check Numbers    */

if (*PARAM(2,4,1,int *) != (-71)) stat |= 0x100;
if (*PARAM(4,4,2,int *) != (-2)) stat |= 0x200;
if (stat) 
   { 
   (void) printf("**** Order of parameters modified ****, status = %x (as %%x)\n",stat); 
   ospexit(1); 
   }

			/* Check Strings    */

/*
printf("s1 = %s|\n",STRIPPED_STRING(s1));
printf("s2 = %s|\n",STRIPPED_STRING(s2));
*/



if (strcmp(STRIPPED_STRING(1,4,0), Cs1)) stat |= 0x10;
if (strcmp(STRIPPED_STRING(3,4,1), Cs2)) stat |= 0x20;
if (stat) 
   { 
   (void) printf("**** String(s) not recognized ****, status = %x (as %%x)\n",stat); 
   ospexit(1); 
   }

/*
printf("successful test: status = %d\n",stat);
*/

ftoc_free(FORmark); /* <forif> */return (stat);
}


#ifdef LinuxAMD64


#if 0     /* ==== Original Code ==== */
SUBROUTINE SSP2(s1, n1, s2, n2, n3, s3)
/*++++++++++++++++
.PURPOSE  Check Fortran to C Interface (FORTRAN SSP1 in for_test.for)
.RETURNS  0 (All OK) / -1 (Error)
-----------------*/
        CHARACTER s1;   /* String*79 */
        CHARACTER s2;   /* String*161*/
        CHARACTER s3;   /* String*4  */
        INT n1;         /* -1 */
        INT n2;         /* -2 */
        INT n3;         /* 98765  */
/*
SUBROUTINE SSP2(s1, n1, n2, n3, n4, n5, n6, n7)
CHARACTER s1; 
INT n1;      
INT n2;     
INT n3;    
INT n4;   
INT n5;  
INT n6; 
INT n7;
*/
#else     /* ==== Generated Code === */
#define SSP2	ssp2_
SSP2(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

int  k, stat;  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */



for (k = 1; k <= NSIG; k++)     signal (k,  exception);

stat = 0;
ftoc_free(FORmark); /* <forif> */return (stat);
}

#else

/*==========================================================================*/

#if 0     /* ==== Original Code ==== */
SUBROUTINE SSP2(s1, n1, s2, n2, n3, s3)
/*++++++++++++++++
.PURPOSE  Check Fortran to C Interface (FORTRAN SSP1 in for_test.for)
.RETURNS  0 (All OK) / -1 (Error)
-----------------*/
CHARACTER s1;   /* String*79 */
CHARACTER s2;   /* String*161*/
CHARACTER s3;   /* String*4  */
INT n1;         /* -1 */
INT n2;         /* -2 */
INT n3;         /* 98765  */
#else     /* ==== Generated Code === */
#define SSP2	ssp2_
SSP2(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

static char Cs1[] = "sY<01234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ>";
static char Cs2[] = "s2<abcdefghijklmnopqrstuvwxyz01234567890>XYZ";
static char Cs3[] = "s3.X";

int  k, stat;  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */



for (k = 1; k <= NSIG; k++)	signal (k,  exception);
stat = 0;

printf("in SSP2 !!!!\n");


			/* Check the Length */


if (CHAR_LEN(1,6,0) != 79)	stat += 1;
if (CHAR_LEN(3,6,1) != 161) stat += 2;
if (CHAR_LEN(6,6,2) != 4) stat += 4;

if (stat) 
   {
   (void) printf("**** String length not recognized ****, status = %x (as %%x)\n",stat);
   ospexit(1);
   }

			/* Check Numbers    */


if (*PARAM(2,6,1,int *) != (-1)) stat |= 0x100;
if (*PARAM(4,6,2,int *) != (-2)) stat |= 0x200;
if (*PARAM(5,6,2,int *) != 98765) stat |= 0x400;
if (stat) 
   { 
   (void) printf("**** Order of parameters modified ****, status = %x (as %%x)\n",stat); 
   ospexit(1); 
   }


			/* Check Strings    */

printf("stripped s1 = %s\n",STRIPPED_STRING(1,6,0));
printf("stripped s2 = %s\n",STRIPPED_STRING(3,6,1));
printf("stripped s3 = %s\n",STRIPPED_STRING(6,6,2));

if (strcmp(STRIPPED_STRING(1,6,0), Cs1)) stat |= 0x10;
if (strcmp(STRIPPED_STRING(3,6,1), Cs2)) stat |= 0x20;
if (strcmp(STRIPPED_STRING(6,6,2), Cs3)) stat |= 0x40;
if (stat) 
   { 
   (void) printf("**** String(s) not recognized ****, status = %x (as %%x)\n",stat); 
   ospexit(1); 
   }
 
ftoc_free(FORmark); /* <forif> */return (stat);
}
#endif


/*==========================================================================*/

#if 0     /* ==== Original Code ==== */
SUBROUTINE SSP3(s1, s2, s3)
/*++++++++++++++++
.PURPOSE  Check Fortran to C Interface (FORTRAN SSP in for_test.for)
.RETURNS  0 (All OK) / -1 (Error)
-----------------*/
CHARACTER s1;	/* Fortran String*5 */
CHARACTER s2;	/* Fortran String*4*/
CHARACTER s3;	/* Fortran String*79  */
#else     /* ==== Generated Code === */
#define SSP3	ssp3_
SSP3(int *noargs, ...) 
{ va_list Cargs;
#endif    /* ======================= */
  int FORmark;           /* <forif> */

static char Cs1[] = "Klaus";
static char Cs2[] = "s3.X";
static char Cs3[] = "sY<01234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ>";
 
int  k, j1, j2, j3, stat;  va_start(Cargs,noargs);       /* <forif> */
  FORmark = ftoc_mark(); /* <forif> */



for (k = 1; k <= NSIG; k++)	signal (k,  exception);
stat = 0;

			/* Check the Length */

/*
j1 = CHAR_LEN(s1);
j2 = CHAR_LEN(s2);
j3 = CHAR_LEN(s3);
printf("length of s1 = %d, s2 = %d, s3 = %d\n",j1,j2,j3);
*/

if (CHAR_LEN(1,3,0) != 5)	stat += 1;
if (CHAR_LEN(2,3,1) != 4) stat += 2;
if (CHAR_LEN(3,3,2) != 79) stat += 4;

if (stat) 
   {
   (void) printf("**** String length not recognized ****, status = %x (as %%x)\n",stat);
   ospexit(1);
   }



			/* Check Strings    */

/*
printf("s1 = %s|\n",STRIPPED_STRING(s1));
printf("s2 = %s|\n",STRIPPED_STRING(s2));
printf("s3 = %s|\n",STRIPPED_STRING(s3));
*/

if (strcmp(STRIPPED_STRING(1,3,0), Cs1)) stat |= 0x10;
if (strcmp(STRIPPED_STRING(2,3,1), Cs2)) stat |= 0x20;
if (strcmp(STRIPPED_STRING(3,3,2), Cs3)) stat |= 0x40;
if (stat) 
   { 
   (void) printf("**** String(s) not recognized ****, status = %x (as %%x)\n",stat); 
   ospexit(1); 
   }


ftoc_free(FORmark); /* <forif> */return (stat);
}
