! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!  MIDAS procedure verify15.prg  to verify MIDAS commands
!  for long filenames
! 
!  K. Banse     050629
!
!  use as @@ verify15 ffffffffff             with f = 1 or 0 (on/off)
!
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 1111111111 n "Enter control flags for entries: "
!
define/local loop/i/1/1 0
define/local rval/r/1/1 0. ? +lower
define/local ival/i/1/5 0 all +lower
define/local seconds/i/1/2 0,0 ? +lower
define/local rcorr/r/1/20 0. all +lower
define/local icorr/i/1/20 0 all +lower
define/local errsum/i/1/1 0 ? +lower
define/local ccc/c/1/10 0000000000
define/local secs/i/1/2 0,0 ? +lower
define/local myvals/i/1/2 0,0 ? +lower
define/local longdir1/c/1/60 verylongdirectoryforfilestotestmidas ? +lower
define/local longdir2/c/1/60 anotherverylongdirectoryforfilestotestmidas ? +lower
!
delete/temp                             !get rid of old temporary files
! 
write/key sizez/i/1/5 600,600,0,0,0
write/key dispyes/i/1/2 0,0
write/key stop/i/1/1 0
!
write/out +------------------------------------------+
write/out Start of procedure verify15.prg
write/out +------------------------------------------+
!
seconds(1) = m$secs()
write/key ccc {p1}
set/format i1
do loop = 1 2
   if ccc({loop}:{loop}) .eq. "1" @@ verify15,000{loop}
   if errsum .gt. 0 then
      write/out "We got problems with entry 000{loop} in verify15.prg!"
      stop = 1
      return
   endif
enddo
seconds(2) = m$secs()
mid$info(8) = seconds(2)-seconds(1)
!
write/out +------------------------------------------+
write/out procedure verify15.prg:
write/out Total time elapsed = {mid$info(8)} seconds.
write/out All tests o.k. - you deserve a coffee now...
write/out +------------------------------------------+
!
!  here the different sub-procedures
!
entry 0001
!
if aux_mode(1) .lt. 2 return
! 
write/out create subdirs with long names
write/out "------------------------------"
! 
open/file makelongdir.sh write inputi
write/file {inputi} "#!/bin/sh "
write/file {inputi} "mkdir {longdir1}"
write/file {inputi} "cd ./{longdir1}"
write/file {inputi} "mkdir {longdir2}"
write/file {inputi} "cd ./{longdir2}"
write/file {inputi} "echo now in `pwd`"
write/file {inputi} "cp ../../wcstest.mt ."
close/file {inputi}
! 
$ cat ./makelongdir.sh
$ chmod +x ./makelongdir.sh
$ ./makelongdir.sh
!
entry 0002
!
write/out test of loooooooong filenames
write/out "-----------------------------"
! 
$ rm -f middummz*
write/out > copy/ii LONG_FILE_NAME &z
copy/ii ./{longdir1}/{longdir2}/wcstest.mt &z
if m$exist("middummz.bdf") .ne. 1 then
   write/out problems with copy/ii
   errsum = errsum + 1
   return
endif
! 
write/out > copy/dk LONG_FILE_NAME  npix outputi
copy/dk ./{longdir1}/{longdir2}/wcstest.mt npix outputi
if outputi(1) .ne. 353 .or. outputi(2) .ne. 353 then
   write/out problems with copy/dk
   errsum = errsum + 1
   return
endif
! 
write/out > read/descr LONG_FILE_NAME
read/descr ./{longdir1}/{longdir2}/wcstest.mt 
! 
write/out > fft/image LONG_FILE_NAME
fft/image ./{longdir1}/{longdir2}/wcstest.mt 
! 
write/keyw rcorr  2.981000e+03,1.395000e+04
write/out > statistics/image LONG_FILE_NAME 
statist/image ./{longdir1}/{longdir2}/wcstest.mt 
@@ kcompare rcorr outputr 1,2 0.3
!
entry 0003
!
entry 0004
!
entry 0005
!
entry 0006
!
entry 0007
!
entry 0008
!



