#
# ------------------------------------------------------
#
# shell procedure dbassign.sh
# define logical names for calibration database
#
# J.D.Ponz 890130
#
# ------------------------------------------------------
#
DB_DATA=$MIDASHOME/calib/data; export DB_DATA

DB_CASPEC=$MIDASHOME/calib/data/inst/caspec;  export DB_CASPEC
RAW_CASPEC=$MIDASHOME/calib/raw/inst/caspec;  export RAW_CASPEC
DB_EFOSC=$MIDASHOME/calib/data/inst/efosc;    export DB_EFOSC
RAW_EFOSC=$MIDASHOME/calib/raw/inst/efosc;    export RAW_EFOSC
DB_IRSPEC=$MIDASHOME/calib/data/inst/irspec;  export DB_IRSPEC
RAW_IRSPEC=$MIDASHOME/calib/raw/inst/irspec;  export RAW_IRSPEC
DB_EMMI=$MIDASHOME/calib/data/inst/emmi;      export DB_EMMI
RAW_EMMI=$MIDASHOME/calib/raw/inst/emmi;      export RAW_EMMI
DB_FEROS=$MIDASHOME/calib/data/inst/feros;      export DB_FEROS
RAW_FEROS=$MIDASHOME/calib/raw/inst/feros;      export RAW_FEROS

DB_CTIO=$MIDASHOME/calib/data/spec/ctio;      export DB_CTIO
RAW_CTIO=$MIDASHOME/calib/raw/spec/ctio;      export RAW_CTIO
DB_FLUX=$MIDASHOME/calib/data/spec/flux;      export DB_FLUX
RAW_FLUX=$MIDASHOME/calib/raw/spec/flux;      export RAW_FLUX
DB_OFLUX=$MIDASHOME/calib/data/spec/flux_old; export DB_OFLUX
RAW_OFLUX=$MIDASHOME/calib/raw/spec/flux_old; export RAW_OFLUX
DB_LYM=$MIDASHOME/calib/data/spec/lyman;      export DB_LYM
RAW_LYM=$MIDASHOME/calib/raw/spec/lyman;      export RAW_LYM

DB_EXTI=$MIDASHOME/calib/data/spec/exti;      export DB_EXTI
RAW_EXTI=$MIDASHOME/calib/raw/spec/exti;      export RAW_EXTI
DB_FLUX=$MIDASHOME/calib/data/spec/flux;      export DB_FLUX
DB_LINE=$MIDASHOME/calib/data/spec/line;      export DB_LINE
RAW_LINE=$MIDASHOME/calib/raw/spec/line;      export RAW_LINE
DB_PEPSYS=$MIDASHOME/calib/data/pepsys;       export DB_PEPSYS
RAW_PEPSYS=$MIDASHOME/calib/raw/pepsys;       export RAW_PEPSYS

DB_TRANS=$MIDASHOME/calib/data/datatrans;     export DB_TRANS
RAW_TRANS=$MIDASHOME/calib/raw/datatrans;     export RAW_TRANS
DB_FILTERS=$DB_TRANS/filters;                 export DB_FILTERS
RAW_FILTERS=$RAW_TRANS/filters;               export RAW_FILTERS
DB_CCD=$DB_TRANS/ccd;                         export DB_CCD
RAW_CCD=$RAW_TRANS/ccd;                       export RAW_CCD
DB_HST=$DB_TRANS/hststd;                      export DB_HST
RAW_HST=$RAW_TRANS/hststd;                    export RAW_HST

# Creating directories for data if they do not exist.
for dir in $DB_DATA $DB_DATA/inst $DB_DATA/spec $DB_CASPEC $DB_EFOSC $DB_IRSPEC $DB_FEROS $DB_EMMI $DB_EXTI $DB_FLUX $DB_LINE $DB_PEPSYS $DB_CTIO $DB_OFLUX $DB_TRANS $DB_LYM $DB_FEROS
do
	if [ ! -d $dir ] 
	then
		echo "	creating $dir"
		mkdir $dir
	fi
done
